import java.io.File;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.HashMap;
import java.util.Scanner;

public class App {

  public static void main(String[] args) {
    try {
      File file = new File("/Users/ondi/Desktop/KWWAAA/numbers/numbers.text");
      MaxMin(file);
      AritmetickyPriemer(file);
      Modus(file);
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  public static void MaxMin(File file) {
    int max = Integer.MIN_VALUE;
    int min = Integer.MAX_VALUE;

    try (Scanner scanner = new Scanner(file)) {
      while (scanner.hasNextInt()) {
        int number = scanner.nextInt();
        if (number > max) {
          max = number;
        }
        if (number < min) {
          min = number;
        }
      }
      System.out.println("Maximum number: " + max);
      System.out.println("Minimum number: " + min);
    } catch (Exception e) {
      System.out.println("Error processing the file.");
      e.printStackTrace();
    }
  }

  public static void AritmetickyPriemer(File file) {
    double sum = 0;
    int count = 0;

    try (Scanner scanner = new Scanner(file)) {
      while (scanner.hasNextDouble()) {
        sum += scanner.nextDouble();
        count++;
      }

      if (count > 0) {
        double mean = sum / count;
        BigDecimal roundedMean = new BigDecimal(mean)
          .setScale(3, RoundingMode.HALF_UP);
        System.out.println("Aritmeticky Priemer : " + roundedMean);
      } else {
        System.out.println("No numbers found in the file.");
      }
    } catch (Exception e) {
      System.out.println("Error processing the file.");
      e.printStackTrace();
    }
  }

  public static void Modus(File file) {
    HashMap<Integer, Integer> frequencyMap = new HashMap<>();
    int maxFrequency = 0;
    Integer mode = null;

    try (Scanner scanner = new Scanner(file)) {
      while (scanner.hasNextInt()) {
        int number = scanner.nextInt();
        int count = frequencyMap.getOrDefault(number, 0) + 1;
        frequencyMap.put(number, count);

        if (count > maxFrequency) {
          maxFrequency = count;
          mode = number;
        }
      }

      if (mode != null) {
        System.out.println("Modus: " + mode);
      } else {
        System.out.println(
          "No mode found (file might be empty or has non-integer values)."
        );
      }
    } catch (Exception e) {
      System.out.println("Error processing the file.");
      e.printStackTrace();
    }
  }
}
